/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup STM32L0xx_HAL_Examples
  * @{
  */

/** @addtogroup Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
static	GPIO_InitTypeDef GPIO_InitStruct;

/* Private function prototypes -----------------------------------------------*/
static void SystemClock_Config(void);
static void Error_Handler(void);


/* Private functions ---------------------------------------------------------*/




//#define x_width 20
//#define x_height 54
static uint8_t ButtonOff[] = {
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x1c, 0x00, 0xf0, 
0x38, 0x00, 0xf0, 
0x70, 0x00, 0xf0, 
0xe0, 0x00, 0xf0, 
0xc0, 0x01, 0xf0, 
0x80, 0x03, 0xf0, 
0x00, 0x07, 0xf0, 
0x00, 0x0e, 0xf0, 
0x00, 0x1c, 0xf0, 
0x00, 0x38, 0xf0, 
0x00, 0x70, 0xf0, 
0x00, 0xe0, 0xf0, 
0x00, 0xc0, 0xf1, 
0x00, 0x80, 0xf3, 
0x00, 0x00, 0xf7, 
0x00, 0x00, 0xf6, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x00, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
}; 

//#define x_width 20
//#define x_height 54
static uint8_t ButtonOn[] = {
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
0x0c, 0x00, 0xf0, 
}; 


static int flag = 0;

static void Button1OffButton2Off ()
{
	BSP_EPD_Clear(EPD_COLOR_WHITE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 1", LEFT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "Off", LEFT_MODE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 2", RIGHT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "Off", RIGHT_MODE);
	BSP_EPD_DrawImage(10, 3, 20, 54, ButtonOff);
	BSP_EPD_DrawImage(108, 3, 20, 54, ButtonOff);
	BSP_EPD_RefreshDisplay();
}

static void Button1OnButton2Off ()
{
	BSP_EPD_Clear(EPD_COLOR_WHITE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 1", LEFT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "On", LEFT_MODE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 2", RIGHT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "Off", RIGHT_MODE);
	BSP_EPD_DrawImage(10, 3, 20, 54, ButtonOn);
	BSP_EPD_DrawImage(108, 3, 20, 54, ButtonOff);
	BSP_EPD_RefreshDisplay();
}

static void Button1OffButton2On ()
{
	BSP_EPD_Clear(EPD_COLOR_WHITE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 1", LEFT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "Off", LEFT_MODE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 2", RIGHT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "On", RIGHT_MODE);
	BSP_EPD_DrawImage(10, 3, 20, 54, ButtonOff);
	BSP_EPD_DrawImage(108, 3, 20, 54, ButtonOn);
	BSP_EPD_RefreshDisplay();
}

static void Button1OnButton2On ()
{
	BSP_EPD_Clear(EPD_COLOR_WHITE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 1", LEFT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "On", LEFT_MODE);
	BSP_EPD_DisplayStringAt(10, 14, (uint8_t*) "Button 2", RIGHT_MODE);
	BSP_EPD_DisplayStringAt(28, 11, (uint8_t*) "On", RIGHT_MODE);
	BSP_EPD_DrawImage(10, 3, 20, 54, ButtonOn);
	BSP_EPD_DrawImage(108, 3, 20, 54, ButtonOn);
	BSP_EPD_RefreshDisplay();
}

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */
int main(void)
{

  /* STM32L0xx HAL library initialization:
       - Configure the Flash prefetch, Flash preread and Buffer caches
       - Systick timer is configured by default as source of time base, but user 
             can eventually implement his proper time base source (a general purpose 
             timer for example or other time source), keeping in mind that Time base 
             duration should be kept 1ms since PPP_TIMEOUT_VALUEs are defined and 
             handled in milliseconds basis.
       - Low Level Initialization
     */
  HAL_Init();
  BSP_EPD_Init();
	BSP_PB_Init(BUTTON_KEY, BUTTON_MODE_GPIO);
	
	/* Interrupt Detect Pin Config */
	
	/* Enable GPIOA clock */
  __GPIOA_CLK_ENABLE();
  
  /* Configure PA0 pin as input */
  GPIO_InitStruct.Pin =  (GPIO_PIN_1);
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT; 
	GPIO_InitStruct.Pull = GPIO_PULLDOWN;
  GPIO_InitStruct.Speed = GPIO_SPEED_FAST;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct); 

	/*-----------------------------------------------------------*/
	

   /* Add your application code here
     */

	HAL_GPIO_WritePin(GPIOA, GPIO_PIN_2, GPIO_PIN_RESET);
	Button1OffButton2Off ();

	
  /* Infinite loop */ // PB0 - INPUT L3 PB1 - OUTPUT L4
  while (1)
  {
		if (BSP_PB_GetState(BUTTON_KEY) == 0 && flag != 0 && HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) == GPIO_PIN_RESET) 
		{
			Button1OffButton2Off ();
			flag = 0;
		}
		
		if (BSP_PB_GetState(BUTTON_KEY) == 1 && flag != 1 && HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) == GPIO_PIN_RESET) 
		{
			Button1OnButton2Off ();
			flag = 1;
		}	
		
		if (BSP_PB_GetState(BUTTON_KEY) == 0 && flag != 2 && HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) == GPIO_PIN_SET) 
		{
			Button1OffButton2On ();
			flag = 2;
		}	
		
		if (BSP_PB_GetState(BUTTON_KEY) == 1 && flag != 3 && HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) == GPIO_PIN_SET) 
		{
			Button1OnButton2On ();
			flag = 3;
		}	
  }
}

/**
  * @brief  System Clock Configuration
  *         The system Clock is configured as follow : 
  *            System Clock source            = MSI
  *            SYSCLK(Hz)                     = 2000000
  *            HCLK(Hz)                       = 2000000
  *            AHB Prescaler                  = 1
  *            APB1 Prescaler                 = 1
  *            APB2 Prescaler                 = 1
  *            Flash Latency(WS)              = 0
  *            Main regulator output voltage  = Scale3 mode
  * @param  None
  * @retval None
  */
static void SystemClock_Config(void)
{
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_OscInitTypeDef RCC_OscInitStruct;
  
  /* Enable Power Control clock */
  __PWR_CLK_ENABLE();
  
  /* The voltage scaling allows optimizing the power consumption when the device is 
     clocked below the maximum system frequency, to update the voltage scaling value 
     regarding system frequency refer to product datasheet.  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE3);
  
  /* Enable MSI Oscillator */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_MSI;
  RCC_OscInitStruct.MSIState = RCC_MSI_ON;
  RCC_OscInitStruct.MSIClockRange = RCC_MSIRANGE_5;
  RCC_OscInitStruct.MSICalibrationValue=0x00;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_NONE;
  if(HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    /* Initialization Error */
    Error_Handler();
  }
  
  
  /* Select MSI as system clock source and configure the HCLK, PCLK1 and PCLK2 
     clocks dividers */
  RCC_ClkInitStruct.ClockType = (RCC_CLOCKTYPE_SYSCLK | RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2);
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_MSI;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;  
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;  
  if(HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_0) != HAL_OK)
  {
    /* Initialization Error */
    Error_Handler();
  }
}


/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
static void Error_Handler(void)
{
  /* User may add here some code to deal with this error */
  while(1)
  {
  }
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif
